#include <iostream>
#include <cmath>
using namespace std;

int main()
{
	int n = 0; // number of items
	int B = 0; // capacity
	int weight[100] = {0}; // weights 
	
	cin >> B >> n;
	for (int i = 0; i < n; i++)
		cin >> weight[i];
	
	bool canFill = false; // a flag marking whether the knapsack can be filled
	
	for (int i = 0; i < pow(2, n); i++)
	{
		int totalWeight = 0;
		
		// convert the integer to a binary string
		int decimal = i;
		for (int j = n - 1; j >= 0; j--)
		{
			int power = static_cast<int>(pow(2, j));
			cout << decimal / power; // only the integer part
			
			if (decimal / power == 1) // this bit is 1; this item is selected
				totalWeight += weight[j]; 
				
			decimal = decimal % power; 	// decrease decimal by the 
										// amount represented by the bit
		}
		
		cout << " " << totalWeight << endl;
		
		if (totalWeight == B) // can fill the knapsack
		{
			cout << "Yes!" << endl;
			canFill = true;
			break;
		}
	}
	
	if (canFill == false)
		cout << "No... orz" << endl;
	
	return 0;
}
